Description

When an user, say "DanielLobato" in LDAP gets an account in Foreman, the login is automatically downcased to "daniellobato". This

causes issues when external user groups refresh, as we perform a 'where' query on User, using the logins from LDAP to check what

users belong in an external user group. So by calling User.where { :name => ['DanielLobato'] } on usergroup.rb, we will get no results

and the user 'daniellobato' will be left unsynced.

Associated revisions

Revision 2ef6f4da - 09/04/2015 06:38 AM - Daniel Lobato Garcia

Fixes #11407 - Uppercase logins from LDAP break external user group sync

On LDAP the login can contain uppercase chars, for instance, "FOO". However

when we log in Foreman for the first time and have that account auto-created,

we can login using "foo". After that, our login will be saved as "foo" on

Foreman.

When a user group that contains said group is refreshed, we pull the names

from LDAP, auth_source.users_in_group(name). This will return an array

containing "FOO". After that, we will call usergroup.add_users(["FOO"])

which in turn calls User.where(:login => ["FOO"]). This will be empty since

our login in the database is "foo".

This commit fixes this issue in two places:

One, by saving the login as it comes from LDAP (case aware), so that

in the previous example 'FOO' would've been saved even if the user had

try to login as 'foo'.

Two, by making add_users and remove_users case insensitive.

Revision 05b5cf34 - 09/22/2015 07:06 AM - Daniel Lobato Garcia

Fixes #11407 - Uppercase logins from LDAP break external user group sync

On LDAP the login can contain uppercase chars, for instance, "FOO". However

when we log in Foreman for the first time and have that account auto-created,

we can login using "foo". After that, our login will be saved as "foo" on

Foreman.

When a user group that contains said group is refreshed, we pull the names

from LDAP, auth_source.users_in_group(name). This will return an array

containing "FOO". After that, we will call usergroup.add_users(["FOO"])

which in turn calls User.where(:login => ["FOO"]). This will be empty since

our login in the database is "foo".

This commit fixes this issue in two places:

One, by saving the login as it comes from LDAP (case aware), so that

in the previous example 'FOO' would've been saved even if the user had

try to login as 'foo'.

Two, by making add_users and remove_users case insensitive.
 (cherry picked from commit 2ef6f4da99a4375e7d4600da62d6ba011e7467d4)

History

#1 - 08/18/2015 02:29 PM - Daniel Lobato Garcia

- Bugzilla link set to 1238442

#2 - 08/18/2015 02:42 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2616 added

- Pull request deleted ()

#3 - 09/04/2015 06:40 AM - Dominic Cleal

- Category changed from Users, Roles and Permissions to Authentication

- Assignee set to Daniel Lobato Garcia

- translation missing: en.field_release set to 72

#4 - 09/04/2015 07:01 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 2ef6f4da99a4375e7d4600da62d6ba011e7467d4.

#5 - 09/15/2015 09:53 AM - Dominic Cleal

- translation missing: en.field_release changed from 72 to 88
